<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="System.Reflection" %>
<%@ Import Namespace="ASPPDFLib" %>

<script LANGUAGE="JavaScript">

</script>


<script runat="server" LANGUAGE="C#">

void Page_Load(Object Source, EventArgs E)
{
	if( !IsPostBack )
	{
		txtBusinessName.Text = "MyCompany, Inc.";
		Type1.Checked = true;
		txtAddress.Text = "2304 Broadway, Suite 10";
		txtCity.Text = "New York";
		txtState.Text = "NY";
		txtZip.Text = "10001";

		TIN1.Checked = true;
		txtEIN.Text = "12-3456789";
		
	}

	if( TIN0.Checked )
	{
		vldSSN.Enabled = true;
		vldSSNReq.Enabled = true;

		vldEIN.Enabled = false; // disable validation of EIN
		vldEINReq.Enabled = false;
		
	}

	if( TIN1.Checked )
	{
		vldSSN.Enabled = false;  // disable validation of SSN
		vldSSNReq.Enabled = false;

		vldEIN.Enabled = true;
		vldEINReq.Enabled = true;
	}

	vldOtherReq.Enabled = Type3.Checked;

	lblResult.Text = "";

	// to keep sessionID (used for file name generation) from changing every time
	Session["dummy"] = 1; 
}



public void GeneratePDF(object sender, System.EventArgs args)
{
	// do manual validation of Name/BusinessName
	if( txtName.Text == "" && txtBusinessName.Text == "" )
	{
		lblResult.Text = "<font color=red>Either Name or Business name must be specified.</font>";
		return;
	}

	// create instance of the PDF manager
	IPdfManager objPDF;
	objPDF = new PdfManager();

	// Create new document
	IPdfDocument objDoc = objPDF.OpenDocument( Server.MapPath( "images/w9.pdf" ), Missing.Value );

	// Obtain page 1 of the document
	IPdfPage objPage = objDoc.Pages[1];

	// Create empty param object to be used throughout the app
	IPdfParam objParam = objPDF.CreateParam(Missing.Value);
    
	IPdfFont objFont = objDoc.Fonts["Helvetica-Bold", Missing.Value]; // a standard font

	// Name
	objParam.Add("x=70, y=698");
	objPage.Canvas.DrawText( txtName.Text, objParam, objFont );

	// Business Name
	objParam.Add("y=674");
	objPage.Canvas.DrawText( txtBusinessName.Text, objParam, objFont );

	// Draw a check mark in a business type box using standard ZapfDingbat font
	float x = 150F, y = 653F;
		
	if( Type1.Checked )
		x = 229F;

	if( Type2.Checked )
		x = 294F;

	if( Type3.Checked )
		x = 351.5F;

	objParam["x"].Value = x;
	objParam["y"].Value = y;
	objPage.Canvas.DrawText( "4", objParam, objDoc.Fonts["ZapfDingbats", Missing.Value] );


	// Other
	if( Type3.Checked && txtOther.Text != "" )
	{
		objParam.Add("x=397, y=653");
		objPage.Canvas.DrawText( txtOther.Text, objParam, objFont );
	}

	// Exempt checkbox
	if( chkExempt.Checked )
	{
		objPage.Canvas.DrawText( "4", "x=480.5; y=653", objDoc.Fonts["ZapfDingbats", Missing.Value] );
	}

	// Address
	objParam.Add("x=70, y=626");
	objPage.Canvas.DrawText( txtAddress.Text, objParam, objFont );

	// City, State, Zip
	objParam.Add("y=602");
	objPage.Canvas.DrawText( txtCity.Text + ", " + txtState.Text + " " + txtZip.Text, objParam, objFont );

	// SSN or EIN
	String strTIN;
	if( TIN0.Checked )
	{
		y = 533;
		strTIN = txtSSN.Text;
	}
	else
	{
		y = 493;
		strTIN = txtEIN.Text;
	}

	x = 433;
	float dX = 14.4F; // box size
	for( int i = 0; i < strTIN.Length; i++ )
	{
		if( (char)strTIN[i] >= '0' && (char)strTIN[i] <= '9' )
		{
			objParam["x"].Value = x;
			objParam["y"].Value = y;
			objPage.Canvas.DrawText( strTIN[i].ToString(), objParam, objFont );
			x = x + dX;
		}
	}

	// Date
	objParam.Add("x=432, y=337");
	objPage.Canvas.DrawText( objPDF.FormatDate(DateTime.Today, "%b %d, %Y"), objParam, objFont );

	// Signature - taken from a .gif file (image itself) and .bmp (mask)
	IPdfImage objSignatureImg = objDoc.OpenImage( Server.MapPath( "images/sig.jpg" ), Missing.Value );
	IPdfImage objMaskImg = objDoc.OpenImage( Server.MapPath( "images/sig.bmp" ), Missing.Value );
	objMaskImg.IsMask = true;
	objSignatureImg.SetImageMask( objMaskImg );  // For transparency purposes

    objPage.Canvas.DrawImage(objSignatureImg, "x=164; y=280; scalex=.5, scaley=.5; angle=20");

	// We use Session ID for file names.
	// false means "do not overwrite"
	// The method returns generated file name.
	String strPath = Server.MapPath( "files") + "\\" + Session.SessionID + ".pdf";
	String strFileName = objDoc.Save( strPath, false );

	lblResult.Text = "Success. Your PDF file <font color=gray>" + strFileName + "</font> can be downloaded <A HREF=\"files/" + strFileName + "\"><B>here</B></A>.";
}

</script>

<HTML>
<HEAD>
<TITLE>AspPDF Template Fill-out Demo</TITLE>
</HEAD>
<BODY>

<TABLE WIDTH="640"><TR><TD>
<FONT FACE="Arial" SIZE="2">
<A HREF="images/w9.pdf"><IMG ALT="Download the original (blank) form W-9 here" SRC="images/w9.gif" ALIGN="RIGHT" BORDER="0"></A>
<h3>AspPDF Template Fill-out Demo</h3>
AspPDF is capable of printing and drawing over existing PDF documents.
This demo enables you to programmatically fill out the IRS W-9 form with
data coming from an HTML form.

<P>
<TABLE BORDER="0" CELLSPACING="3" CELLPADDING="0" STYLE="font-name:arial; font-size: 12">

<FORM ID="Form" runat="server" METHOD="POST">

<TR><TD><B>Name</B>:</TD><TD><ASP:TextBox SIZE="40" ID="txtName" runat="server"/></TD></TR>

<TR><TD><B>Business Name</B>:</TD><TD><ASP:TextBox SIZE="40" ID="txtBusinessName" runat="server"/>
</TD></TR>

<TR><TD VALIGN="TOP"><B>Type</B>:</TD><TD>
	<ASP:RadioButton AutoPostback="true" ID="Type0" VALUE="0" GroupName="Type" runat="server"/>Individual/Sole Proprietor<BR>
	<ASP:RadioButton AutoPostback="true" ID="Type1" VALUE="1" GroupName="Type" runat="server"/>Corporation<BR>
	<ASP:RadioButton AutoPostback="true" ID="Type2" VALUE="2" GroupName="Type" runat="server"/>Partnership<BR>
	<ASP:RadioButton AutoPostback="true" NAME="Type3" ID="Type3" VALUE="3" GroupName="Type" runat="server"/>Other  <ASP:TextBox OnFocus="javascript:this.form.Type3.checked=true;" ID="txtOther" runat="server"/>
		<ASP:RequiredFieldValidator id="vldOtherReq" ControlToValidate="txtOther" Display="dynamic" ErrorMessage="Other type must be specified." runat="server" />
</TD></TR>

<TR><TD><B>Exempt from<BR>backup<BR>withholdings</B>?</TD><TD><ASP:CheckBox ID="chkExempt" runat="server"/></TD></TR>

<TR><TD><B>Street Address</B>:</TD><TD><ASP:TextBox SIZE="40" ID="txtAddress" runat="server"/>
<ASP:RequiredFieldValidator id="vldAddressReq" ControlToValidate="txtAddress" Display="dynamic" ErrorMessage="Address must be specified." runat="server" />
</TD></TR>

<TR><TD><B>City</B>:</TD><TD><ASP:TextBox SIZE="40" ID="txtCity" runat="server"/>
<ASP:RequiredFieldValidator id="vldCityReq" ControlToValidate="txtCity" Display="dynamic" ErrorMessage="City must be specified." runat="server" />
</TD></TR>

<TR><TD><B>State</B>:</TD><TD><ASP:TextBox SIZE="2" ID="txtState" runat="server"/>
<ASP:RequiredFieldValidator id="vldStateReq" ControlToValidate="txtState" Display="dynamic" ErrorMessage="State must be specified." runat="server" />
</TD></TR>
<TR><TD><B>Zip</B>:</TD><TD><ASP:TextBox SIZE="10" ID="txtZip" runat="server"/>
<ASP:RequiredFieldValidator id="vldZipReq" ControlToValidate="txtZip" Display="dynamic" ErrorMessage="Zip must be specified." runat="server" />
</TD></TR>

<TR><TD VALIGN="CENTER"><B>Taxpayer Number</B>:</TD><TD>
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 STYLE="font-name:arial; font-size: 12">
	<TR>
		<TD><ASP:RadioButton AutoPostback="true" NAME="TIN0" ID="TIN0" GroupName="TIN" VALUE="0" runat="server"/>SSN</TD>
		<TD><ASP:TextBox ID="txtSSN" OnFocus="this.form.TIN0.checked=true" runat="server"/>
			<ASP:RegularExpressionValidator ControlToValidate="txtSSN" ValidationExpression="^\d{3}-\d{2}-\d{4}$" ErrorMessage="Please enter SSN in the format NNN-NN-NNNN." ID="vldSSN" runat="server" Display="dynamic"/>
			<ASP:RequiredFieldValidator id="vldSSNReq" ControlToValidate="txtSSN" Display="dynamic" ErrorMessage="SSN must be specified." runat="server" />
		</TD>
		
		</TR>
	<TR>
		<TD><ASP:RadioButton AutoPostback="true" NAME="TIN1" ID="TIN1" GroupName="TIN" VALUE="1" runat="server"/>EIN</TD>
		<TD><ASP:TextBox ID="txtEIN" OnFocus="this.form.TIN1.checked=true" runat="server"/>
		<ASP:RegularExpressionValidator ControlToValidate="txtEIN" ValidationExpression="^\d{2}-\d{7}$" ErrorMessage="Please enter EIN in the format NN-NNNNNNN." ID="vldEIN" runat="server" Display="dynamic"/>
		<ASP:RequiredFieldValidator id="vldEINReq" ControlToValidate="txtEIN" Display="dynamic" ErrorMessage="EIN must be specified." runat="server" />
		</TD>
		
	</TR>
	</TABLE>
</TD></TR>

<TR><TD COLSPAN="2"><ASP:Button OnClick="GeneratePDF" ID="btnSave" Text="Generate PDF" runat="server"/></TD></TR>

<TR><TD COLSPAN="2">&nbsp;</TD></TR>

<TR><TD COLSPAN="2"><B><ASP:Label ID="lblResult" runat="server"/></B></TD></TR>

</FORM>
</TABLE>

<P>
<B><A HREF="demo_fill.zip">Download source code (ASP and ASP.NET/C#) for this demo</A></B>

</FONT>
</TABLE
>
</BODY>
</HTML>

